<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Multiple Regions</TITLE>
<link href="transform_7.html" rel=Next>
<link href="transform_5.html" rel=Previous>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_5.html">previous</A>, <A HREF="transform_7.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC6" HREF="transform_toc.html#TOC6">Multiple Regions</A></H3>

<P>
In this section we describe how to generate multiple tiled regions in a
single loop nest.
We can treat the following loop nest of depth 4 as two regions of depth two,
and tile the <CODE>i</CODE> and <CODE>j</CODE> loops together, and tile the <CODE>k</CODE> and
<CODE>l</CODE> loops together.  

</P>

<PRE>
for (i = 0; i &#60;= N; i++) {
    for (j = 0; j &#60;= N; j++) {
        for (k = 0; k &#60;= N; k++) {
            for (l = 0; l &#60;= N; l++) {
                ...
            }
        }
    }
}
</PRE>

<P>
To create blocks of size 100, we'd use the following parameters:

</P>

<PRE>
trip[0] = 100; trip[1] = 100; trip[2] = 100; trip[3] = 100;
nregions = 2;
coalesce[0] = FALSE; coalesce[1] = FALSE;
first[0] = 0; first[1] = 2; first[2] = 4;
</PRE>

<P>
The resulting code is:

</P>

<PRE>

for (i_tile = 0; i_tile &#60;= N; i_tile += 100) {
  for (j_tile = 0; j_tile &#60;= N; j_tile += 100) {
    for (i = i_tile; i &#60;= min(N, i_tile + 99); i++) {
      for (j = max(0, j_tile); j &#60;= min(N, j_tile + 99); j++) {

        for (k_tile = 0; k_tile &#60;= N; k_tile += 100) {
          for (l_tile = 0; l_tile &#60;= N; l_tile += 100) {
            for (k = k_tile; k &#60;= min(N, k_tile + 99); k++) {
              for (l = max(0, l_tile); j &#60;= min(N, l_tile + 99); l++) {
                        ...
              }
            }
          }
        }

      }
    }
  }
}

</PRE>

<P><HR><P>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_5.html">previous</A>, <A HREF="transform_7.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
